diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/eht-phy.cc ns-3.45/src/wifi/model/eht/eht-phy.cc
--- ns-3.44/src/wifi/model/eht/eht-phy.cc	2025-03-09 16:55:49.787372600 -0700
+++ ns-3.45/src/wifi/model/eht/eht-phy.cc	2025-06-01 20:34:45.614702200 -0700
@@ -8,9 +8,12 @@
 
 #include "eht-phy.h"
 
+#include "eht-configuration.h"
 #include "eht-ppdu.h"
 
 #include "ns3/interference-helper.h"
+#include "ns3/obss-pd-algorithm.h"
+#include "ns3/wifi-net-device.h"
 #include "ns3/wifi-phy.h"
 #include "ns3/wifi-psdu.h"
 #include "ns3/wifi-utils.h"
@@ -43,6 +46,16 @@
                               WIFI_PPDU_FIELD_DATA } }
 };
 
+/**
+ * \brief map a given secondary channel width to its channel list type
+ */
+const std::map<MHz_u, WifiChannelListType> ehtSecondaryChannels {
+    {20, WIFI_CHANLIST_SECONDARY},
+    {40, WIFI_CHANLIST_SECONDARY40},
+    {80, WIFI_CHANLIST_SECONDARY80},
+    {160, WIFI_CHANLIST_SECONDARY160},
+};
+
 // clang-format on
 
 EhtPhy::EhtPhy(bool buildModeList /* = true */)
@@ -76,6 +89,16 @@
     }
 }
 
+uint16_t
+EhtPhy::GetUsableSubcarriers(MHz_u channelWidth)
+{
+    if (channelWidth == MHz_u{320})
+    {
+        return 3920;
+    }
+    return HePhy::GetUsableSubcarriers(channelWidth);
+}
+
 WifiMode
 EhtPhy::GetSigMode(WifiPpduField field, const WifiTxVector& txVector) const
 {
@@ -339,7 +362,7 @@
     auto bw = txVector.GetChannelWidth();
     if (txVector.IsMu())
     {
-        bw = HeRu::GetBandwidth(txVector.GetRu(staId).GetRuType());
+        bw = WifiRu::GetBandwidth(WifiRu::GetRuType(txVector.GetRu(staId)));
     }
     return EhtPhy::GetPhyRate(txVector.GetMode(staId).GetMcsValue(),
                               bw,
@@ -353,7 +376,7 @@
     auto bw = txVector.GetChannelWidth();
     if (txVector.IsMu())
     {
-        bw = HeRu::GetBandwidth(txVector.GetRu(staId).GetRuType());
+        bw = WifiRu::GetBandwidth(WifiRu::GetRuType(txVector.GetRu(staId)));
     }
     return EhtPhy::GetDataRate(txVector.GetMode(staId).GetMcsValue(),
                                bw,
@@ -405,6 +428,129 @@
     return dataRate;
 }
 
+dBm_u
+EhtPhy::Per20MHzCcaThreshold(const Ptr<const WifiPpdu> ppdu) const
+{
+    if (!ppdu)
+    {
+        /**
+         * A signal is present on the 20 MHz subchannel at or above a threshold of –62 dBm at the
+         * receiver's antenna(s). The PHY shall indicate that the 20 MHz subchannel is busy a period
+         * aCCATime after the signal starts and shall continue to indicate the 20 MHz subchannel is
+         * busy while the threshold continues to be exceeded (Sec. 36.3.21.6.4 - Per 20 MHz CCA
+         * sensitivity - of 802.11be D7.0).
+         */
+        return m_wifiPhy->GetCcaEdThreshold();
+    }
+
+    /**
+     * A non-HT, HT_MF, HT_GF, VHT, HE, or EHT PPDU for which the power measured within
+     * this 20 MHz subchannel is at or above max(–72 dBm, OBSS_PD level) at the
+     * receiver’s antenna(s). The PHY shall indicate that the 20 MHz subchannel is busy
+     * with greater than 90% probability within a period aCCAMidTime (Sec. 36.3.21.6.4 - Per 20 MHz
+     * CCA sensitivity - of 802.11be D7.0).
+     */
+    auto ehtConfiguration = m_wifiPhy->GetDevice()->GetEhtConfiguration();
+    NS_ASSERT(ehtConfiguration);
+    const auto ccaThresholdNonObss = ehtConfiguration->m_per20CcaSensitivityThreshold;
+    return GetObssPdAlgorithm()
+               ? std::max(ccaThresholdNonObss, GetObssPdAlgorithm()->GetObssPdLevel())
+               : ccaThresholdNonObss;
+}
+
+dBm_u
+EhtPhy::GetCcaThreshold(const Ptr<const WifiPpdu> ppdu, WifiChannelListType channelType) const
+{
+    if (channelType != WIFI_CHANLIST_PRIMARY)
+    {
+        return Per20MHzCcaThreshold(ppdu);
+    }
+    return HePhy::GetCcaThreshold(ppdu, channelType);
+}
+
+const std::map<MHz_u, WifiChannelListType>&
+EhtPhy::GetCcaSecondaryChannels() const
+{
+    return ehtSecondaryChannels;
+}
+
+PhyEntity::CcaIndication
+EhtPhy::GetCcaIndicationOnSecondary(const Ptr<const WifiPpdu> ppdu)
+{
+    const auto secondaryWidthsToCheck = GetCcaSecondaryWidths(ppdu);
+
+    for (auto secondaryWidth : secondaryWidthsToCheck)
+    {
+        const auto channelType = ehtSecondaryChannels.at(secondaryWidth);
+        const auto ccaThreshold = GetCcaThreshold(ppdu, channelType);
+        const auto indices =
+            m_wifiPhy->GetOperatingChannel().GetAll20MHzChannelIndicesInSecondary(secondaryWidth);
+        for (auto index : indices)
+        {
+            const auto band = m_wifiPhy->GetBand(20, index);
+            if (const auto delayUntilCcaEnd = GetDelayUntilCcaEnd(ccaThreshold, band);
+                delayUntilCcaEnd.IsStrictlyPositive())
+            {
+                return std::make_pair(delayUntilCcaEnd, channelType);
+            }
+        }
+    }
+
+    return std::nullopt;
+}
+
+std::vector<Time>
+EhtPhy::GetPer20MHzDurations(const Ptr<const WifiPpdu> ppdu)
+{
+    NS_LOG_FUNCTION(this);
+
+    /**
+     * 36.3.21.6.4 Per 20 MHz CCA sensitivity:
+     * If the operating channel width is greater than 20 MHz and the PHY issues a PHY-CCA.indication
+     * primitive, the PHY shall set the per20bitmap to indicate the busy/idle status of each 20 MHz
+     * subchannel.
+     */
+    if (m_wifiPhy->GetChannelWidth() < 40)
+    {
+        return {};
+    }
+
+    std::vector<Time> per20MhzDurations{};
+    const auto indices = m_wifiPhy->GetOperatingChannel().GetAll20MHzChannelIndicesInPrimary(
+        m_wifiPhy->GetChannelWidth());
+    for (auto index : indices)
+    {
+        auto band = m_wifiPhy->GetBand(20, index);
+        /**
+         * A signal is present on the 20 MHz subchannel at or above a threshold of –62 dBm at the
+         * receiver's antenna(s). The PHY shall indicate that the 20 MHz subchannel is busy a period
+         * aCCATime after the signal starts and shall continue to indicate the 20 MHz subchannel is
+         * busy while the threshold continues to be exceeded.
+         */
+        dBm_u ccaThreshold = -62;
+        auto delayUntilCcaEnd = GetDelayUntilCcaEnd(ccaThreshold, band);
+
+        if (ppdu)
+        {
+            const MHz_u subchannelMinFreq =
+                m_wifiPhy->GetFrequency() - (m_wifiPhy->GetChannelWidth() / 2) + (index * 20);
+            const MHz_u subchannelMaxFreq = subchannelMinFreq + 20;
+            const auto ppduBw = ppdu->GetTxVector().GetChannelWidth();
+
+            if ((ppduBw <= m_wifiPhy->GetChannelWidth()) &&
+                ppdu->DoesOverlapChannel(subchannelMinFreq, subchannelMaxFreq))
+            {
+                ccaThreshold = Per20MHzCcaThreshold(ppdu);
+                const auto ppduCcaDuration = GetDelayUntilCcaEnd(ccaThreshold, band);
+                delayUntilCcaEnd = std::max(delayUntilCcaEnd, ppduCcaDuration);
+            }
+        }
+        per20MhzDurations.push_back(delayUntilCcaEnd);
+    }
+
+    return per20MhzDurations;
+}
+
 } // namespace ns3
 
 namespace
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/eht-phy.h ns-3.45/src/wifi/model/eht/eht-phy.h
--- ns-3.44/src/wifi/model/eht/eht-phy.h	2025-03-09 16:55:49.787372600 -0700
+++ ns-3.45/src/wifi/model/eht/eht-phy.h	2025-06-01 20:34:45.614702200 -0700
@@ -54,6 +54,8 @@
                             const WifiTxVector& txVector,
                             Time ppduDuration) override;
     WifiMode GetSigBMode(const WifiTxVector& txVector) const override;
+    Time CalculateNonHeDurationForHeTb(const WifiTxVector& txVector) const override;
+    Time CalculateNonHeDurationForHeMu(const WifiTxVector& txVector) const override;
 
     /**
      * Initialize all EHT modes.
@@ -249,9 +251,12 @@
                                 PhyFieldRxStatus status,
                                 WifiPpduField field) override;
     WifiPhyRxfailureReason GetFailureReason(WifiPpduField field) const override;
-    Time CalculateNonHeDurationForHeTb(const WifiTxVector& txVector) const override;
-    Time CalculateNonHeDurationForHeMu(const WifiTxVector& txVector) const override;
     uint32_t GetSigBSize(const WifiTxVector& txVector) const override;
+    dBm_u GetCcaThreshold(const Ptr<const WifiPpdu> ppdu,
+                          WifiChannelListType channelType) const override;
+    const std::map<MHz_u, WifiChannelListType>& GetCcaSecondaryChannels() const override;
+    PhyEntity::CcaIndication GetCcaIndicationOnSecondary(const Ptr<const WifiPpdu> ppdu) override;
+    std::vector<Time> GetPer20MHzDurations(const Ptr<const WifiPpdu> ppdu) override;
 
     /**
      * Create and return the EHT MCS corresponding to
@@ -278,8 +283,24 @@
      */
     static uint64_t CalculateNonHtReferenceRate(WifiCodeRate codeRate, uint16_t constellationSize);
 
+    /**
+     * @param channelWidth the channel width
+     * @return he number of usable subcarriers for data
+     */
+    static uint16_t GetUsableSubcarriers(MHz_u channelWidth);
+
+    /**
+     * Compute the CCA threshold for Per 20MHz check.
+     * This threshold is used for CCA check when signal is not occupying P20 or for Per 20MHz CCA
+     * check.
+     *
+     * @param ppdu the incoming PPDU or nullptr for any signal
+     * @return the CCA threshold for Per 20MHz check
+     */
+    dBm_u Per20MHzCcaThreshold(const Ptr<const WifiPpdu> ppdu) const;
+
     static const PpduFormats m_ehtPpduFormats; //!< EHT PPDU formats
-};                                             // class EhtPhy
+};
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/eht-ppdu.cc ns-3.45/src/wifi/model/eht/eht-ppdu.cc
--- ns-3.44/src/wifi/model/eht/eht-ppdu.cc	2025-03-09 16:55:49.787372600 -0700
+++ ns-3.45/src/wifi/model/eht/eht-ppdu.cc	2025-06-01 20:34:45.614702200 -0700
@@ -13,8 +13,10 @@
 #include "ns3/log.h"
 #include "ns3/wifi-phy-operating-channel.h"
 #include "ns3/wifi-psdu.h"
+#include "ns3/wifi-utils.h"
 
 #include <algorithm>
+#include <initializer_list>
 #include <numeric>
 
 namespace ns3
@@ -28,7 +30,7 @@
                  Time ppduDuration,
                  uint64_t uid,
                  TxPsdFlag flag)
-    : HePpdu(psdus, txVector, channel, ppduDuration, uid, flag)
+    : HePpdu(psdus, txVector, channel, ppduDuration, uid, flag, false)
 {
     NS_LOG_FUNCTION(this << psdus << txVector << channel << ppduDuration << uid << flag);
     SetPhyHeaders(txVector, ppduDuration);
@@ -38,6 +40,7 @@
 EhtPpdu::SetPhyHeaders(const WifiTxVector& txVector, Time ppduDuration)
 {
     NS_LOG_FUNCTION(this << txVector << ppduDuration);
+    SetLSigHeader(ppduDuration);
     SetEhtPhyHeader(txVector);
 }
 
@@ -50,7 +53,8 @@
     {
         const auto p20Index = m_operatingChannel.GetPrimaryChannelIndex(MHz_u{20});
         m_ehtPhyHeader.emplace<EhtMuPhyHeader>(EhtMuPhyHeader{
-            .m_bandwidth = GetChannelWidthEncodingFromMhz(txVector.GetChannelWidth()),
+            .m_bandwidth =
+                GetChannelWidthEncodingFromMhz(txVector.GetChannelWidth(), m_operatingChannel),
             .m_bssColor = bssColor,
             .m_ppduType = txVector.GetEhtPpduType(),
             // TODO: EHT PPDU should store U-SIG per 20 MHz band, assume it is the lowest 20 MHz
@@ -70,18 +74,54 @@
              * sounding NDP, the Common field of the EHT-SIG content channel is encoded together
              * with the first User field and this encoding block contains a CRC and Tail, referred
              * to as a common encoding block. */
-            .m_ruAllocationA =
-                txVector.IsMu() ? std::optional{txVector.GetRuAllocation(p20Index)} : std::nullopt,
+            .m_ruAllocationA = txVector.IsMu() && !txVector.IsSigBCompression()
+                                   ? std::optional{txVector.GetRuAllocation(p20Index)}
+                                   : std::nullopt,
             // TODO: RU Allocation-B not supported yet
             .m_contentChannels = GetEhtSigContentChannels(txVector, p20Index)});
     }
     else if (ns3::IsUlMu(m_preamble))
     {
-        m_ehtPhyHeader.emplace<EhtTbPhyHeader>(EhtTbPhyHeader{
-            .m_bandwidth = GetChannelWidthEncodingFromMhz(txVector.GetChannelWidth()),
-            .m_bssColor = bssColor,
-            .m_ppduType = txVector.GetEhtPpduType()});
+        m_ehtPhyHeader.emplace<EhtTbPhyHeader>(
+            EhtTbPhyHeader{.m_bandwidth = GetChannelWidthEncodingFromMhz(txVector.GetChannelWidth(),
+                                                                         m_operatingChannel),
+                           .m_bssColor = bssColor,
+                           .m_ppduType = txVector.GetEhtPpduType()});
+    }
+}
+
+uint8_t
+EhtPpdu::GetChannelWidthEncodingFromMhz(MHz_u channelWidth, const WifiPhyOperatingChannel& channel)
+{
+    NS_ASSERT(channel.GetTotalWidth() >= channelWidth);
+    if (channelWidth == MHz_u{320})
+    {
+        switch (channel.GetNumber())
+        {
+        case 31:
+        case 95:
+        case 159:
+            return 4;
+        case 63:
+        case 127:
+        case 191:
+            return 5;
+        default:
+            NS_ASSERT_MSG(false, "Invalid 320 MHz channel number " << +channel.GetNumber());
+            return 4;
+        }
+    }
+    return HePpdu::GetChannelWidthEncodingFromMhz(channelWidth);
+}
+
+MHz_u
+EhtPpdu::GetChannelWidthMhzFromEncoding(uint8_t bandwidth)
+{
+    if ((bandwidth == 4) || (bandwidth == 5))
+    {
+        return MHz_u{320};
     }
+    return HePpdu::GetChannelWidthMhzFromEncoding(bandwidth);
 }
 
 WifiPpduType
@@ -132,7 +172,7 @@
         {
             // TODO: use punctured channel information
         }
-        txVector.SetSigBMode(HePhy::GetVhtMcs(ehtPhyHeader->m_ehtSigMcs));
+        txVector.SetSigBMode(EhtPhy::GetVhtMcs(ehtPhyHeader->m_ehtSigMcs));
         txVector.SetGuardInterval(GetGuardIntervalFromEncoding(ehtPhyHeader->m_giLtfSize));
         const auto ruAllocation = ehtPhyHeader->m_ruAllocationA; // RU Allocation-B not supported
                                                                  // yet
@@ -149,12 +189,14 @@
                                       [](uint8_t prev, const auto& cc) { return prev + cc.size(); })
                     : 0;
             SetHeMuUserInfos(txVector,
+                             WIFI_MOD_CLASS_EHT,
                              ruAllocation.value(),
+                             std::nullopt,
                              ehtPhyHeader->m_contentChannels,
                              ehtPhyHeader->m_ppduType == 2,
                              muMimoUsers);
         }
-        if (ehtPhyHeader->m_ppduType == 1) // EHT SU
+        else if (ehtPhyHeader->m_ppduType == 1) // EHT SU
         {
             NS_ASSERT(ehtPhyHeader->m_contentChannels.size() == 1 &&
                       ehtPhyHeader->m_contentChannels.front().size() == 1);
@@ -162,6 +204,14 @@
                 EhtPhy::GetEhtMcs(ehtPhyHeader->m_contentChannels.front().front().mcs));
             txVector.SetNss(ehtPhyHeader->m_contentChannels.front().front().nss);
         }
+        else
+        {
+            const auto fullBwRu{EhtRu::RuSpec(WifiRu::GetRuType(bw), 1, true, true)};
+            txVector.SetHeMuUserInfo(ehtPhyHeader->m_contentChannels.front().front().staId,
+                                     {fullBwRu,
+                                      ehtPhyHeader->m_contentChannels.front().front().mcs,
+                                      ehtPhyHeader->m_contentChannels.front().front().nss});
+        }
     }
     else if (ns3::IsUlMu(m_preamble))
     {
@@ -185,7 +235,9 @@
         return {1, 0};
     }
     return HePpdu::GetNumRusPerHeSigBContentChannel(channelWidth,
+                                                    WIFI_MOD_CLASS_EHT,
                                                     ruAllocation,
+                                                    std::nullopt,
                                                     compression,
                                                     numMuMimoUsers);
 }
@@ -302,6 +354,64 @@
     return 0;
 }
 
+Ptr<const WifiPsdu>
+EhtPpdu::GetPsdu(uint8_t bssColor, uint16_t staId /* = SU_STA_ID */) const
+{
+    if (m_psdus.contains(SU_STA_ID))
+    {
+        NS_ASSERT(m_psdus.size() == 1);
+        return m_psdus.at(SU_STA_ID);
+    }
+
+    if (IsUlMu())
+    {
+        auto ehtPhyHeader = std::get_if<EhtTbPhyHeader>(&m_ehtPhyHeader);
+        NS_ASSERT(ehtPhyHeader);
+        NS_ASSERT(m_psdus.size() == 1);
+        if ((bssColor == 0) || (ehtPhyHeader->m_bssColor == 0) ||
+            (bssColor == ehtPhyHeader->m_bssColor))
+        {
+            return m_psdus.cbegin()->second;
+        }
+    }
+    else if (IsDlMu())
+    {
+        auto ehtPhyHeader = std::get_if<EhtMuPhyHeader>(&m_ehtPhyHeader);
+        NS_ASSERT(ehtPhyHeader);
+        if ((bssColor == 0) || (ehtPhyHeader->m_bssColor == 0) ||
+            (bssColor == ehtPhyHeader->m_bssColor))
+        {
+            const auto it = m_psdus.find(staId);
+            if (it != m_psdus.cend())
+            {
+                return it->second;
+            }
+        }
+    }
+
+    return nullptr;
+}
+
+WifiRu::RuSpec
+EhtPpdu::GetRuSpec(std::size_t ruAllocIndex, MHz_u bw, RuType ruType, std::size_t phyIndex) const
+{
+    if (ruType == RuType::RU_26_TONE)
+    {
+        for (const auto undefinedRu : std::initializer_list<std::size_t>{19, 56, 93, 130})
+        {
+            if (phyIndex >= undefinedRu)
+            {
+                ++phyIndex;
+            }
+        }
+    }
+    const auto p20Index = m_operatingChannel.GetPrimaryChannelIndex(MHz_u{20});
+    const auto& [primary160, primary80OrLow80] =
+        EhtRu::GetPrimaryFlags(bw, ruType, phyIndex, p20Index);
+    const auto index = EhtRu::GetIndexIn80MHzSegment(bw, ruType, phyIndex);
+    return EhtRu::RuSpec{ruType, index, primary160, primary80OrLow80};
+}
+
 Ptr<WifiPpdu>
 EhtPpdu::Copy() const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/eht-ppdu.h ns-3.45/src/wifi/model/eht/eht-ppdu.h
--- ns-3.44/src/wifi/model/eht/eht-ppdu.h	2025-03-09 16:55:49.787372600 -0700
+++ ns-3.45/src/wifi/model/eht/eht-ppdu.h	2025-06-01 20:34:45.614702200 -0700
@@ -41,7 +41,7 @@
         uint8_t m_bandwidth : 3 {0};    ///< Bandwidth field
         uint8_t m_bssColor : 6 {0};     ///< BSS color field
         uint8_t m_ppduType : 2 {0};     ///< PPDU Type And Compressed Mode field
-    };                                  // struct EhtTbPhyHeader
+    };
 
     /**
      * PHY header for EHT MU PPDUs
@@ -65,7 +65,7 @@
                                                      //!< carried in EHT-SIG common subfields
 
         HeSigBContentChannels m_contentChannels; //!< EHT-SIG Content Channels
-    };                                           // struct EhtMuPhyHeader
+    };
 
     /// type of the EHT PHY header
     using EhtPhyHeader = std::variant<std::monostate, EhtTbPhyHeader, EhtMuPhyHeader>;
@@ -90,6 +90,7 @@
             TxPsdFlag flag);
 
     WifiPpduType GetType() const override;
+    Ptr<const WifiPsdu> GetPsdu(uint8_t bssColor, uint16_t staId = SU_STA_ID) const override;
     Ptr<WifiPpdu> Copy() const override;
 
     /**
@@ -150,6 +151,12 @@
                                     uint8_t ehtPpduType,
                                     std::optional<bool> isLow80MHz);
 
+  protected:
+    WifiRu::RuSpec GetRuSpec(std::size_t ruAllocIndex,
+                             MHz_u bw,
+                             RuType ruType,
+                             std::size_t phyIndex) const override;
+
   private:
     bool IsDlMu() const override;
     bool IsUlMu() const override;
@@ -161,7 +168,7 @@
      * @param txVector the TXVECTOR that was used for this PPDU
      * @param ppduDuration the transmission duration of this PPDU
      */
-    void SetPhyHeaders(const WifiTxVector& txVector, Time ppduDuration);
+    void SetPhyHeaders(const WifiTxVector& txVector, Time ppduDuration) override;
 
     /**
      * Fill in the EHT PHY header.
@@ -170,8 +177,26 @@
      */
     void SetEhtPhyHeader(const WifiTxVector& txVector);
 
+    /**
+     * Convert channel width expressed in MHz to bandwidth field encoding in U-SIG.
+     *
+     * @param channelWidth the channel width in MHz to use for the transmission
+     * @param channel the operating channel of the PHY
+     * @return the value used to encode the bandwidth field in U-SIG
+     */
+    static uint8_t GetChannelWidthEncodingFromMhz(MHz_u channelWidth,
+                                                  const WifiPhyOperatingChannel& channel);
+
+    /**
+     * Convert channel width expressed in MHz from bandwidth field encoding in U-SIG.
+     *
+     * @param bandwidth the value of the bandwidth field in U-SIG
+     * @return the channel width in MHz
+     */
+    static MHz_u GetChannelWidthMhzFromEncoding(uint8_t bandwidth);
+
     EhtPhyHeader m_ehtPhyHeader; //!< the EHT PHY header
-};                               // class EhtPpdu
+};
 
 } // namespace ns3
 
